MODULE INTEGRAL
  IMPLICIT NONE

CONTAINS

	! ηּӳ
	REAL FUNCTION Rectangle_Integral(FX, H)
	  IMPLICIT NONE
	! 
	  REAL :: FX(:)
	  REAL :: H
	  REAL :: S
	  INTEGER :: I, Nodes
	! ֵ
	  Nodes = SIZE(FX)
	  S = 0.0
	  DO I = 1, Nodes
		S = S + FX(I)
	  ENDDO
	  Rectangle_Integral = S * H
	  RETURN

	END FUNCTION Rectangle_Integral

	! ηּӳ
	REAL FUNCTION Trape_Integral(FX, H)
	  IMPLICIT NONE
	! 
	  REAL :: FX(:)
	  REAL :: H
	  REAL :: S
	  INTEGER :: I, Nodes
	! ֵ
	  Nodes = SIZE(FX)
	  S = (FX(1) + FX(Nodes))/2.0
	  DO I = 2, Nodes-1
		S = S + FX(I)
	  ENDDO
	  Trape_Integral = S * H
	  RETURN

	END FUNCTION Trape_Integral

	! SimpsonĻּӳ
	REAL FUNCTION Simpson_Integral(FX, H)
	  IMPLICIT NONE
	! 
	  REAL :: FX(:)
	  REAL :: H
	  REAL :: F4
	  REAL :: F2
	  INTEGER :: I, Nodes
	! Ϣ
	  Nodes = SIZE(FX)
	  IF(0 == (MOD(Nodes, 2))) THEN
		WRITE(*, '(1X, A)') 'The numbers of discrete data must be odd!'
		Simpson_Integral = HUGE(1.0)
		RETURN
	  ENDIF
	! ֵ
	  F4 = 0.0
	  F2 = 0.0
	  DO I = 2, Nodes-1
		IF(0 == MOD(I, 2)) THEN
		  F4 = F4 + FX(I)
		ELSE
		  F2 = F2 + FX(I)
		ENDIF
	  ENDDO
	  Trape_Integral = H / 3.0 * (FX(1) + FX(Nodes) + 4.0*F4 + 2.0*F2)
	  RETURN

	END FUNCTION Simpson_Integral

END MODULE INTEGRAL

! ַ
PROGRAM TEST1401
  USE INTEGRAL
  IMPLICIT NONE
! 
  REAL, ALLOCATABLE :: FX(:)
  REAL :: A
  REAL :: B
  REAL :: H
  REAL :: X
  REAL :: S
  INTEGER :: N
  INTEGER :: I
  INTEGER :: ERR
! Ļʾ
  PRINT *, 'Input start point & end point:'
  READ(*, *)A, B
  PRINT *, 'Input numbers of sub zone:'
  READ(*, *)N
  ALLOCATE(FX(N), STAT=ERR)
  IF(0 /= ERR) THEN
    PRINT *, 'Failure in allocating array!'
    STOP
  ENDIF
! 
  PRINT *, 'Generate data:'
  H = (B - A) / N
  X = A
  DO I = 1, N
    FX(I) = SIN(X) / (1.0 + X)
    X = X + H
  ENDDO
! ֲ
  PRINT *, 'Select integral method: 1- Rectangle 2- Trape 3- Simpson 0- Exit'
  READ(*, *)I
  DO WHILE(0 /= I)
    SELECT CASE(I)
      CASE(1)
        S = Rectangle_Integral(FX, H)
      CASE(2)
        S = Trape_Integral(FX, H)
      CASE(3)
        IF(1 == MOD(N, 2)) PRINT *, 'Simpson method need odd points! Please restart the program!'
        S = Simpson_Integral(FX, H)
    END SELECT
! ӡ
    PRINT*, 'Output the results:'
    WRITE(*, '(1X, 2(A, F7.2, 1X), A, I4)')'A = ', A, 'B = ', B, 'N = ', N
    WRITE(*, '(1X, A, F16.7)')'S = ', S

    PRINT *, 'Continue: 1- Rectangle 2- Trape 3- Simpson 0- Exit'
    READ(*, *)I
  ENDDO

END PROGRAM TEST1401



