SUBROUTINE Gauss_Expunction(A, B, X, N)
  IMPLICIT NONE
! 
  INTEGER :: N
  REAL :: A(N,N), B(N)
  REAL :: X(N)
  INTEGER :: I, J
  REAL :: C
  LOGICAL, EXTERNAL :: Check_Root

  ! Ԫ
  DO J = 1, N-1
    IF(.NOT. Check_Root(A, J, N)) THEN
      PRINT *, '޽Ψһ'
      STOP 'ֹͣںCheck_Root'
    ENDIF
    CALL Transfer_Max(A, B, J, N)
    DO I = J+1, N
      C = A(I, J)/A(J, J)
      B(I) = B(I) - B(J)*C
      A(I, J:N) = A(I, J:N) - A(J, J:N)*C
    ENDDO
  ENDDO
  ! ش
  X(N) = B(N)/A(N, N)
  DO I = N-1, 1, -1
    C = 0.0
    DO J = I+1, N
      C = C + A(I, J)*X(J)
    ENDDO
    X(I) = (B(I) - C)/A(I, I)
  ENDDO

END SUBROUTINE Gauss_Expunction

LOGICAL FUNCTION Check_Root(A, J, N)
  IMPLICIT NONE
! 
  INTEGER :: N
  REAL :: A(N,N)
  INTEGER :: J
  INTEGER :: I
 ݴ
  DO I = J, N
    IF(A(I, J) /= 0.0) THEN
      Check_Root = .TRUE.
      RETURN
    ENDIF
  ENDDO
  Check_Root = .FALSE.
  RETURN

END FUNCTION Check_Root

SUBROUTINE Transfer_Max(A, B, J, N)
  IMPLICIT NONE
! 
  INTEGER :: N
  REAL :: A(N,N)
  REAL :: B(N)
  INTEGER :: J
  INTEGER :: I, K 
! ݴ
  K = J
  DO I = J, N
    IF(ABS(A(I, J)) > ABS(A(J, J))) K = I
  ENDDO
  IF(K == J) RETURN
  CALL Swap_Element(B(J), B(K))
  DO I = J, N
    CALL Swap_Element(A(J, I), A(K, I))
  ENDDO

CONTAINS
! Ԫɨӳ
  SUBROUTINE Swap_Element(A, B)
    IMPLICIT NONE

    REAL :: A, B
    REAL :: C

    C = A
    A = B
    B = C

  END SUBROUTINE Swap_Element

END SUBROUTINE Transfer_Max

! ˹ȥķ
PROGRAM TEST1402
  IMPLICIT NONE
! 
  REAL, ALLOCATABLE :: A(:,:), B(:), X(:)
  INTEGER :: N, I, J, Err
! Ļʾ洢ռ
  WRITE(*, '(1X,A)')'뷽еķ̸:'
  READ(*, *)N
  ALLOCATE(A(N,N), STAT=Err)
  IF(0 /= Err) STOP '̬䷽ϵʧ!'
  ALLOCATE(B(N), STAT=Err)
  IF(0 /= Err) STOP '̬䷽ʧ!'
  ALLOCATE(X(N), STAT=Err)
  IF(0 /= Err) STOP '̬䷽ʧ!'
! Ļʾ
  WRITE(*, '(1X,A,I3,A,I3,A)')'',N,'X',N,'ϵ:'
  DO I = 1, N
    READ(*, *)(A(I, J), J = 1, N)
  ENDDO
  WRITE(*, '(1X,A,I3,A,I3,A)')'',N,'ֵ:'
  READ(*, *)(B(I), I = 1, N)
! ˹ȥ
  CALL Gauss_Expunction(A, B, X, N)

  WRITE(*, '(1X,A)')'Ľ:'
  WRITE(*, '(1X,"X(",I2,") = ", F10.6)')(I, X(I), I=1,N)

END PROGRAM TEST1402
