MODULE NOLINEAREQUATION
  IMPLICIT NONE

CONTAINS

  ! ӳ
  REAL FUNCTION Basic_Iteration(Funx, X, N, E)
    IMPLICIT NONE
  ! 
    REAL, EXTERNAL :: Funx
    REAL :: X
    INTEGER :: N
    REAL :: E
    INTEGER :: I
    REAL :: Xn
  ! 
    DO I = 1, N
      Xn = Funx(X)
      WRITE(*, '(1X, "I=", I3.3, 2X, "X=", F15.7)')I, Xn
      IF(E > ABS(Xn - X)) THEN
        Basic_Iteration = Xn
        RETURN
      ELSE
        X = Xn
      ENDIF
    ENDDO
    WRITE(*, '(1X, A)')'The maximum iteration number is reached!'
    Basic_Iteration = HUGE(1.0)
    RETURN

  END FUNCTION Basic_Iteration

  ! ţٵӳ
  REAL FUNCTION Newton_Iteration(Funx, Funx1, X, N, E)
    IMPLICIT NONE
  ! 
    REAL, EXTERNAL :: Funx
    REAL, EXTERNAL :: Funx1
    REAL :: X
    INTEGER :: N
    REAL :: E
    INTEGER :: I
    REAL :: Xn
  ! ţٵ
    DO I = 1, N
      Xn = X - Funx(X)/Funx1(X)
      WRITE(*, '(1X, "I=", I3.3, 2X, "X=", F15.7)')I, Xn
      IF((E > ABS(Xn - X)) .OR. (E > ABS(Funx(Xn)))) THEN
        Newton_Iteration = Xn
        RETURN
      ELSE
        X = Xn
      ENDIF
    ENDDO
    WRITE(*, '(1X, A)')'The maximum iteration number is reached!'
    Newton_Iteration = HUGE(1.0)
    RETURN

  END FUNCTION Newton_Iteration

  ! ַӳ
  REAL FUNCTION Bisection_Iteration(Funx, Xa, Xb, E)
    IMPLICIT NONE
  ! 
    REAL, EXTERNAL :: Funx
    REAL :: Xa
    REAL :: Xb
    REAL :: E
    INTEGER :: I
    REAL :: Xc
    REAL :: Fa
    REAL :: Fb
    REAL :: Fc
  ! ȷʼ²ȷ
    Fa = Funx(Xa)
    Fb = Funx(Xb)
    IF(Fa*Fb < 0.0) THEN
      WRITE(*, '(1X, A)')'This is a wrong guess of A & B!'
      Bisection_Iteration = HUGE(1.0)
      RETURN
    ENDIF
  ! ַ
    I = 1
    DO
      Fa = Funx(Xa)
      Fb = Funx(Xb)
      Xc = (Xa + Xb) / 2.0
      Fc = Funx(Xc)
      WRITE(*, '(1X, "I=", I3.3, 2X, "X=", F15.7)')I, Xc
      IF(E > ABS(Fc)) THEN
        EXIT
      ELSE
        IF(Fa*Fc < 0.0) THEN
          Xb = Xc
        ELSE
          Xa = Xc
        ENDIF
      ENDIF
      I = I + 1
    ENDDO
    Bisection_Iteration = Xc
    RETURN

  END FUNCTION Bisection_Iteration

  ! ҽطӳ
  REAL FUNCTION Secant_Iteration(Funx, Xa, Xb, N, E)
    IMPLICIT NONE
  ! 
    REAL, EXTERNAL :: Funx
    REAL :: Xa
    REAL :: Xb
    INTEGER :: N
    REAL :: E
    INTEGER :: I
    REAL :: Xc
    REAL :: Fa
    REAL :: Fb
    REAL :: Fc
  ! ȷʼ²ȷ
    Fa = Funx(Xa)
    Fb = Funx(Xb)
    IF(Fa*Fb > 0.0) THEN
      WRITE(*, '(1X, A)')'This is a wrong guess of A & B!'
      Secant_Iteration = HUGE(1.0)
      RETURN
    ENDIF
  ! ҽط
    DO I = 1, N
      Fa = Funx(Xa)
      Fb = Funx(Xb)
      Xc = Xb - Funx(Xb)*(Xb - Xa)/(Funx(Xb) - Funx(Xa))
      Fc = Funx(C)
      WRITE(*, '(1X, "I=", I3.3, 2X, "X=", F15.7)')I, Xc
      IF(E > ABS(Fc)) THEN
        Secant_Iteration = Xc
        RETURN
      ELSE
        IF(Fa*Fc < 0.0) THEN
          Xb = Xc
        ELSE
          Xa = Xc
        ENDIF
      ENDIF
    ENDDO
    WRITE(*, '(1X, A)')'The maximum iteration number is reached!'
    Secant_Iteration = HUGE(1.0)
    RETURN

  END FUNCTION Secant_Iteration

END MODULE NOLINEAREQUATION

! Է
PROGRAM TEST1404
  USE NOLINEAREQUATION
  IMPLICIT NONE
! 
  REAL :: Xa
  REAL :: Xb
  REAL :: S
  REAL :: E
  INTEGER :: N
  INTEGER :: I
! Ļʾ
  PRINT *, 'Select a method from the following:'
  PRINT *, '1. Basic Iteration'
  PRINT *, '2. Newton Iteration'
  PRINT *, '3. Bisection Iteration'
  PRINT *, '4. Secant Iteration'
  PRINT *, '5. Draw the Line'
  PRINT *, '0. Exit Program'
  READ(*, *)I
! ûѡӦĽⷨ
  SELECT CASE (I)
    CASE (1)
      PRINT *, 'Input the guess(X), iteration number(N) & iteration precision(E):'
      READ(*, *)Xa, N, E
      S = Basic_Iteration(Funx2, Xa, N, E)
    CASE (2)
      PRINT *, 'Input the guess(X), iteration number(N) & iteration precision(E):'
      READ(*, *)Xa, N, E
      S = Newton_Iteration(Funx, Funx1, Xa, N, E)
    CASE (3)
      PRINT *, 'Input the guess(Xa, Xb), iteration precision(E):'
      READ(*, *)Xa, Xb, E
      S = Bisection_Iteration(Funx, Xa, Xb, E)
    CASE (4)
      PRINT *, 'Input the guess(Xa, Xb), iteration number(N) & iteration precision(E):'
      READ(*, *)Xa, Xb, N, E
      S = Secant_Iteration(Funx, Xa, Xb, N, E)
    CASE (5)
      PRINT *, 'Input the zone(Xa, Xb), subzone number(N):'
      READ(*, *)Xa, Xb, N
      S = DrawFun(Funx, Xa, Xb, N)
      STOP
  END SELECT
  IF(S < HUGE(1.0)) THEN
    PRINT*, 'Output the results:' 
    IF(1==I .AND. 2==I) WRITE(*, '(1X, A, F7.2)') 'Xa = ', Xa
    IF(3==I .AND. 4==I) WRITE(*, '(1X, 2(A, F7.2, 1X))') 'Xa = ', Xa, 'Xb = ', Xb
    IF(3 /= I) WRITE(*, '(1X, A, I4)') 'N = ', N
    WRITE(*, '(1X, A, F16.7)') 'E =', E
    WRITE(*, '(1X, A, F16.7)') 'S = ', S
  ENDIF

CONTAINS
! ԭʼԺ
  REAL FUNCTION Funx(x)
    IMPLICIT NONE

    REAL :: X
    
    Funx = X**3 - 5.0*X**2 + 14.0*X - 20.0
    RETURN
  
  END FUNCTION Funx
! һ׵
  REAL FUNCTION Funx1(x)
    IMPLICIT NONE

    REAL :: X
    
    Funx1 = 2.0*X**2 - 10.0*X + 14.0
    RETURN
  
  END FUNCTION Funx1
! 
  REAL FUNCTION Funx2(x)
    IMPLICIT NONE

    REAL :: X
    
    Funx2 = (20.0 - X**3 + 5.0*X**2)/14.0
    RETURN
  
  END FUNCTION Funx2
! ͼ
  INTEGER FUNCTION DrawFun(Funx, X1, X2, N)
    IMPLICIT NONE
! 
    REAL, EXTERNAL :: Funx
    REAL :: X1, X2
    INTEGER :: N
    REAL :: H, Xn, S
    INTEGER :: I
! ͼļ
    H = (X2 - X1)/N
    OPEN(UNIT = 10, FILE = 'DrawFun.PLT')
      WRITE(10, '(A)')'TITLE = TEST1402 Line Draw'
      DO I = 1, N+1
        Xn = X1 + H*(I-1)
        S = Funx(Xn)
        WRITE(10, *)Xn, S
      ENDDO
    CLOSE(10)
    DrawFun = 0
    RETURN

  END FUNCTION DrawFun

END PROGRAM TEST1404

