! 
FUNCTION Rung_Kutta(X, Y, X1, F) RESULT(Y1)
IMPLICIT NONE
! 
  REAL :: X, Y, X1, Y1
  REAL, EXTERNAL :: F
  REAL :: X0, Y0, H
  REAL :: K0, K1, K2, K3
! ʼֵ
  X0 = X
  Y0 = Y
  H = X1 - X0
! ϵ
  K0 = H*F(Y0, X0)
  K1 = H*F(Y0 + K0/2, X0 + H/2)
  K2 = H*F(Y0 + K1/2, X0 + H/2)
  K3 = H*F(Y0 + K2, X0 + H)
! ֳ
  Y1 = Y0 + (K0 + 2*K1 + 2* K2 + K3)/6.0
  RETURN

END FUNCTION Rung_Kutta

! 䲽
FUNCTION Rung_Kutta_Vs(X, Y, X1, Err, F) RESULT(Y1)
  IMPLICIT NONE
! 
  REAL :: X, Y, X1, Y1, Err
  REAL, EXTERNAL :: F
  REAL :: X0, Y0, H, Temp
  INTEGER :: N, M, I
  REAL :: K0, K1, K2, K3
! ʼϵ
  X0 = X
  Y0 = Y
  N = 1
  H = (X1 - X0)/N
  K0 = H*F(Y0, X0)
  K1 = H*F(Y0 + K0/2, X0 + H/2)
  K2 = H*F(Y0 + K1/2, X0 + H/2)
  K3 = H*F(Y0 + K2, X0 + H)
  Temp = Y0 + (K0 + 2*K1 + 2* K2 + K3)/6.0
! Ӧȷ
  M = 0
  DO
    M = M + 1
    X0 = X
    Y0 = Y
    N = 2*N
    H = (X1 - X0)/N
    Y1 = Temp
    DO I = 1, N
      K0 = H*F(Y0, X0)
      K1 = H*F(Y0 + K0/2, X0 + H/2)
      K2 = H*F(Y0 + K1/2, X0 + H/2)
      K3 = H*F(Y0 + K2, X0 + H)
      Temp = Y0 + (K0 + 2*K1 + 2* K2 + K3)/6.0
      X0 = X0 + H
      Y0 = Temp
    ENDDO
    IF(ABS((Temp - Y1)/Y1)<=Err .OR. M>5000) EXIT
  ENDDO
  IF(M > 5000) THEN
    PRINT *, '! 5000!'
  ENDIF
  Y1 = Temp
  RETURN

END FUNCTION Rung_Kutta_Vs

! ⳡ΢ַ
PROGRAM TEST1406
  IMPLICIT NONE
! 
  REAL :: X0, Y0, X1, Y1
  REAL :: Xn, H, Err, Xt, Yt
  INTEGER :: N, I, Item
  REAL, EXTERNAL :: Rung_Kutta, Rung_Kutta_Vs
! Ļʾ
  PRINT *, 'ⳣ΢: dY/dX = Y*Y - X*X'
  PRINT *, '볣΢̵ĳʼ[X0, Y0]:'
  READ(*, *) X0, Y0
  PRINT *, 'ѡҪõķ:[0:Rung-Kutta 1:ĽRung-Kutta]'
  READ(*, *) Item
  PRINT *, 'յͲ[Xn, N]:'
  READ(*, *) Xn, N
  IF(1 == Item) THEN
    PRINT *, ':'
    READ(*, *) Err
  ENDIF
  H = (Xn - X0)/N
! ӡ
  WRITE(*, 100) X0, Y0
  Xt = X0
  Yt = Y0
  DO I = 1, N
    X1 = H*I + X0
    IF(0 == Item) THEN
      Y1 = Rung_Kutta(Xt, Yt, X1, Funx)
    ELSE
      Y1 = Rung_Kutta_Vs(Xt, Yt, X1, Err, Funx)
    ENDIF
    WRITE(*, 200) I, X1, I, Y1
    Xt = X1
    Yt = Y1
  ENDDO
! ʽ˵
  100 FORMAT(5X, 'X00=', F10.6, ' Y00=', F10.6)
  200 FORMAT(5X, 'X', I2.2, '=', F10.6, ' Y', I2.2, '=', F10.6)

CONTAINS
! ԭ
  REAL FUNCTION Funx(Y, X)
    IMPLICIT NONE

    REAL :: Y, X

    Funx = Y*Y - X*X
    RETURN

  END FUNCTION Funx

END PROGRAM TEST1406

