! ֱӳ
FUNCTION Table_Build(N, Y) RESULT(T)
  IMPLICIT NONE
! 
  INTEGER, INTENT(IN):: N
  REAL, INTENT(IN) :: Y(N)
  REAL :: T(N, N)
  INTEGER :: I, J
! ֱ
  T = 0.0
  DO I = 1, N
    T(I, 1) = Y(I)
  ENDDO
  DO J = 2, N
    DO I = 1, N-J+1
      T(I, J) = T(I+1, J-1) - T(I, J-1)
    ENDDO
  ENDDO
  RETURN

END FUNCTION Table_Build

! ţǰֵӳ
FUNCTION Newton(Xip, Ns, Ne, T, X, H) RESULT(R)
  IMPLICIT NONE
! 
  REAL, INTENT(IN) :: Xip
  INTEGER, INTENT(IN) :: Ns, Ne
  REAL, INTENT(IN) :: T(:, :), X(:), H
  REAL :: R
  REAL :: S, C1
  INTEGER :: F, I, N
! ݼ
  N = SIZE(T, 1)
  IF((Ns + Ne - 1) > N) THEN
    PRINT *, 'ݵ㲻!'
    RETURN
  ENDIF
! ǰֵ
  R = T(Ns, 1)
  S = (Xip - X(Ns))/H
  F = 1
  C1 = 1.0
  DO I = 1, Ne - 1
    F = F*I
    C1 = C1*(S - I +1)
    R = R + C1*T(Ns, I+1)/REAL(F)
  ENDDO
  RETURN

END FUNCTION Newton

! 
PROGRAM TEST1408
  IMPLICIT NONE
! 
  REAL, PARAMETER :: PI = 3.1415926
  REAL :: X(10), Y(10), T(10, 10)
  INTEGER :: Nip
  REAL, ALLOCATABLE :: Xip(:), Yip(:)
  REAL :: H, Inc, Xc
  INTEGER :: I, Err
! ӿ˵
  INTERFACE
    FUNCTION Table_Build(N, Y) RESULT(T)
      IMPLICIT NONE

      INTEGER, INTENT(IN):: N
      REAL, INTENT(IN) :: Y(N)
      REAL :: T(N, N)
    END FUNCTION Table_Build

    FUNCTION Newton(Xip, Ns, Ne, T, X, H) RESULT(R)
      IMPLICIT NONE

      REAL, INTENT(IN) :: Xip
      INTEGER, INTENT(IN) :: Ns, Ne
      REAL, INTENT(IN) :: T(:, :), X(:), H
      REAL :: R
    END FUNCTION Newton
  END INTERFACE
! ʼ
  PRINT *, '10Sinֵ'
  H = 360.0/9.0
  DO I = 1, 10
    X(I) = H*(I - 1)
    Y(I) = SIN(PI*X(I)/180.0)
  ENDDO
  T = Table_Build(10, Y)
! ʼֵ
  PRINT *, 'ҪֵĿ'
  READ(*, *) Nip
  ALLOCATE(Xip(Nip), Yip(Nip), STAT=Err)
  IF(0 == Err) THEN
    Xc = 0.0
    Inc = 360.0/(Nip - 1)
    DO I = 1, Nip
      Xip(I) = Xc
      Yip(I) = Newton(Xip(I), 1, 10, T, X, H)
      !Yip(I) = Newton(Xip(I), 3, 8, T, X, H) !ıֵʼֹӰֵ
      Xc = Xc + Inc
    ENDDO
  ELSE
    PRINT *, '̬ڴʧ!'
    STOP
  ENDIF
! ֵ
  OPEN(10, FILE='Newton.dat')
  WRITE(10, *) "TITLE = Newton Interpolation Result"
  WRITE(10, *) "VARIABLES = 'x' 'y'"
  WRITE(10, *) "ZONE T = 'Origin'"
  DO I = 1, 10
    WRITE(10, *) X(I), Y(I)
  ENDDO
  WRITE(10, *) "ZONE T = 'Newton'"
  DO I = 1, Nip
    WRITE(10, *) Xip(I), Yip(I)
  ENDDO
  CLOSE(10)

  DEALLOCATE(Xip, Yip, STAT=Err)
  IF(0 /= Err) PRINT *, 'ע! ͷŶ̬ڴʧ!'

END PROGRAM TEST1408
