! ѡģ
MODULE SORT_MODULE
  IMPLICIT NONE
! ӿ˵
  INTERFACE Select_Sort
    MODULE PROCEDURE Select_Sort_r
    MODULE PROCEDURE Select_Sort_i
    MODULE PROCEDURE Select_Sort_d
  END INTERFACE

CONTAINS
! ʵѡ
  SUBROUTINE Select_Sort_r(A)
    IMPLICIT NONE
! 
    REAL :: A(:)
    INTEGER :: N, I, J
    REAL :: Min, Temp
! 
    N = SIZE(A)
    DO J = 1, N - 1
      Min = A(J)
      DO I = J+1, N
        IF(Min > A(I)) THEN
          Temp = A(J)
          A(J) = A(I)
          A(I) = Temp
          Min = A(I)
        ENDIF
      ENDDO
    ENDDO

  END SUBROUTINE

! ѡ
  SUBROUTINE Select_Sort_i(A) 
    IMPLICIT NONE
! 
    INTEGER :: A(:)
    INTEGER :: N, I, J
    INTEGER :: Min, Temp
! 
    N = SIZE(A)
    DO J = 1, N - 1
      Min = A(J)
      DO I = J+1, N
        IF(Min > A(I)) THEN
          Temp = A(J)
          A(J) = A(I)
          A(I) = Temp
          Min = A(I)
        ENDIF
      ENDDO
    ENDDO

  END SUBROUTINE

! ˫ѡ
  SUBROUTINE Select_Sort_d(A) 
    IMPLICIT NONE
! 
    REAL(8) :: A(:)
    INTEGER :: N, I, J
    REAL(8) :: Min, Temp
! 
    N = SIZE(A)
    DO J = 1, N - 1
      Min = A(J)
      DO I = J+1, N
        IF(Min > A(I)) THEN
          Temp = A(J)
          A(J) = A(I)
          A(I) = Temp
          Min = A(I)
        ENDIF
      ENDDO
    ENDDO

  END SUBROUTINE

END MODULE SORT_MODULE

! ѡ
PROGRAM TEST1606
  USE SORT_MODULE
  IMPLICIT NONE
! 
  INTEGER, ALLOCATABLE :: I4(:)
  REAL, ALLOCATABLE :: R4(:)
  REAL(8), ALLOCATABLE :: R8(:)
  INTEGER :: N, Type, Err, I
  REAL :: Temp
! ʼ
  PRINT *, ':'
  READ(*, *) N
  PRINT *, 'ѡ[1- 2-ʵ 3-˫]'
  READ(*, *) Type
  CALL RANDOM_SEED()
! ѡ򷽷
  SELECT CASE (Type)
    CASE(1)
      ALLOCATE(I4(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      DO I = 1, N
        CALL RANDOM_NUMBER(Temp)
        I4(I) = ANINT(Temp*5.0)
      ENDDO
      PRINT *, 'ԭʼ:', I4
      CALL Select_Sort(I4)
      PRINT *, ':', I4
    CASE(2)
      ALLOCATE(R4(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      CALL RANDOM_NUMBER(R4)
      PRINT *, 'ԭʼ:', R4
      CALL Select_Sort(R4)
      PRINT *, ':', R4
    CASE(3)
      ALLOCATE(R8(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      CALL RANDOM_NUMBER(R8)
      PRINT *, 'ԭʼ:', R8
      CALL Select_Sort(R8)
      PRINT *, ':', R8
  END SELECT

END PROGRAM TEST1606
