! ģ
MODULE SORT_MODULE
  IMPLICIT NONE
! ӿ˵
  INTERFACE Fast_Sort
    MODULE PROCEDURE Fast_Sort_i
    MODULE PROCEDURE Fast_Sort_r
    MODULE PROCEDURE Fast_Sort_d
  END INTERFACE
CONTAINS
! ʵ
  SUBROUTINE Fast_Sort_r(A, S, E)
    IMPLICIT NONE
! 
    REAL :: A(:)
    INTEGER :: S, E
    INTEGER :: N, L, R, K
    INTEGER :: Temp
! 
    L = S
    R = E + 1
    IF(R >= L) THEN
      K = A(S)
      DO
        DO
          L = L + 1
          IF((A(L) > K) .OR. (L >= E)) EXIT
        ENDDO
        DO
          R = R - 1
          IF((A(R) < K) .OR. (R <= E)) EXIT
        ENDDO
        IF(R <= L) EXIT
        Temp = A(R)
        A(R) = A(L)
        A(L) = Temp
      ENDDO
      Temp = A(S)
      A(S) = A(R)
      A(R) = Temp
      CALL Fast_Sort_r(A, S, R-1)
      CALL Fast_Sort_r(A, R+1, E)
    ENDIF

  END SUBROUTINE Fast_Sort_r

! 
  SUBROUTINE Fast_Sort_i(A, S, E)
    IMPLICIT NONE
! 
    INTEGER :: A(:)
    INTEGER :: S, E
    INTEGER :: N, L, R, K
    INTEGER :: Temp
! 
    L = S
    R = E + 1
    IF(R >= L) THEN
      K = A(S)
      DO
        DO
          L = L + 1
          IF((A(L) > K) .OR. (L >= E)) EXIT
        ENDDO
        DO
          R = R - 1
          IF((A(R) < K) .OR. (R <= E)) EXIT
        ENDDO
        IF(R <= L) EXIT
        Temp = A(R)
        A(R) = A(L)
        A(L) = Temp
      ENDDO
      Temp = A(S)
      A(S) = A(R)
      A(R) = Temp
      CALL Fast_Sort_i(A, S, R-1)
      CALL Fast_Sort_i(A, R+1, E)
    ENDIF

  END SUBROUTINE Fast_Sort_i

! ˫
  SUBROUTINE Fast_Sort_d(A, S, E)
    IMPLICIT NONE
! 
    REAL(8) :: A(:)
    INTEGER :: S, E
    INTEGER :: N, L, R, K
    INTEGER :: Temp
! 
    L = S
    R = E + 1
    IF(R >= L) THEN
      K = A(S)
      DO
        DO
          L = L + 1
          IF((A(L) > K) .OR. (L >= E)) EXIT
        ENDDO
        DO
          R = R - 1
          IF((A(R) < K) .OR. (R <= E)) EXIT
        ENDDO
        IF(R <= L) EXIT
        Temp = A(R)
        A(R) = A(L)
        A(L) = Temp
      ENDDO
      Temp = A(S)
      A(S) = A(R)
      A(R) = Temp
      CALL Fast_Sort_d(A, S, R-1)
      CALL Fast_Sort_d(A, R+1, E)
    ENDIF

  END SUBROUTINE Fast_Sort_d
END MODULE SORT_MODULE

! This is a demo program of Bubble Sort
PROGRAM TEST1607
  USE SORT_MODULE
  IMPLICIT NONE
! 
  INTEGER, ALLOCATABLE :: I4(:)
  REAL, ALLOCATABLE :: R4(:)
  REAL(8), ALLOCATABLE :: R8(:)
  INTEGER :: N, Type, Err, I
  REAL :: Temp
! ʼ
  PRINT *, ':'
  READ(*, *) N
  PRINT *, 'ѡ[1- 2-ʵ 3-˫]'
  READ(*, *) Type
  CALL RANDOM_SEED()
! ѡӳ
  SELECT CASE (Type)
    CASE(1)
      ALLOCATE(I4(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      DO I = 1, N
        CALL RANDOM_NUMBER(Temp)
        I4(I) = ANINT(Temp*5.0)
      ENDDO
      PRINT *, 'ԭʼ:', I4
      CALL Fast_Sort (I4)
      PRINT *, ':', I4
    CASE(2)
      ALLOCATE(R4(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      CALL RANDOM_NUMBER(R4)
      PRINT *, 'ԭʼ:', R4
      CALL Fast_Sort (R4)
      PRINT *, ':', R4
    CASE(3)
      ALLOCATE(R8(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      CALL RANDOM_NUMBER(R8)
      PRINT *, 'ԭʼ:', R8
      CALL Fast_Sort (R8)
      PRINT *, ':', R8
  END SELECT

END PROGRAM TEST1607
